VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CErrorTrace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"CErrorTraceElement"
Attribute VB_Ext_KEY = "Member0" ,"CErrorTraceElement"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'<Auto-Module-Header>===============================================================
' Module: CErrorTrace
'
' Description:
'   This is a collection class that acts as a constructor for ErrorTraceElement objects
'   and as the trace stack for errors.
'-----------------------------------------------------------------------------------
' Version History (When, Who, What):
' 06/03/2001  Roger Swift
'             Added header.
'
'</Auto-Module-Header>==============================================================
Option Explicit

'Local variable to hold collection of (references to) trace elements.
Private mColElements As Collection

'Used in debug and trace calls.
Private Const MODULE_NAME As String = "CErrorTrace"

'A reference to an instance of vbExt used by trace and debug calls.
Private m_oVbExt As vbExt


'<Auto-Procedure-Header>=============================================================
' Function:  CErrorTraceElement Add()
'
' Description:
'   Only method by which an ErrorTraceElement object can be added to the ErrorTrace
'   collection. Also, the only way in which an ErrorTraceElement should be created.
'------------------------------------------------------------------------------------
' Arguments (Name, Type, Description):
' In:  Number           Long    - error number
'      Source           String  - error source
'      Description      String  - error description
'      HelpContext      Long    - help context ID associated with the error
'      HelpFile         String  - help file associated with the error
'      LastDLLError     Long    - error number generated by an API call
'      ModuleName       String  - module from which the error has been reported
'      ProcedureName    String  - procedure from which the error has been reported
'      LineNumber       Long    - number of the line last executed before the error
'                               - These last three arguments relate to the procedure
'                                 where the error was last raised from, not necessarily
'                                 where it occured originally.
'------------------------------------------------------------------------------------
' Returns:  CErrorTraceElement
'   Although this method returns a reference to the ErrorTraceElement created it is
'   not (generally) used.
'------------------------------------------------------------------------------------
' Version History (When, Who, What):
' 06/03/2001  Roger Swift
'             Added header.
'
'</Auto-Procedure-Header>============================================================
Public Function Add(ByVal Number As Long, _
                    ByVal Source As String, _
                    ByVal Description As String, _
                    ByVal HelpContext As Long, _
                    ByVal HelpFile As String, _
                    ByVal LastDLLError As Long, _
                    ByVal ModuleName As String, _
                    ByVal ProcedureName As String, _
                    ByVal LineNumber As Long) As CErrorTraceElement

Dim oNewTraceElement As CErrorTraceElement

Const PROCEDURE_NAME As String = MODULE_NAME & ".Add"
    
    Call m_oVbExt.DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    'Create a new trace element object.
    Set oNewTraceElement = New CErrorTraceElement

    'Set the Trace Element's properties from the arguments passed into the Add method.
    With oNewTraceElement
        .ProcedureName = ProcedureName
        .ModuleName = ModuleName
        .LineNumber = LineNumber
        .HelpContext = HelpContext
        .HelpFile = HelpFile
        .LastDLLError = LastDLLError
        .Source = Source
        .Description = Description
        .Number = Number
    End With
    
    'Add the trace element to the head of the stack.
    If mColElements.Count = 0 Then
        mColElements.Add oNewTraceElement
    Else
        mColElements.Add oNewTraceElement, , 1
    End If

    'Return the trace element created.
    Set Add = oNewTraceElement
    
    'Release this procedure's reference to the trace element.
    Set oNewTraceElement = Nothing


End Function

Public Sub Clear()
'Clear the error stack by removing each trace element.

Dim lCount As Long

Const PROCEDURE_NAME As String = MODULE_NAME & ".Clear"

    Call m_oVbExt.DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    For lCount = mColElements.Count To 1 Step -1
    
        mColElements.Remove lCount
        
    Next lCount
    

End Sub

Public Property Get Item(ByVal lIndex As Long) As CErrorTraceElement
Attribute Item.VB_UserMemId = 0
'Used when referencing an element in the collection.
'Only providing access by index.
    
    Set Item = mColElements(lIndex)
    
End Property

Public Property Get Count() As Long
'Used when retrieving the number of elements in the collection.
    
    Count = mColElements.Count
    
End Property

Public Sub Remove(ByVal lIndex As Long)
'Used when removing an element from the collection.
'Only providing access by index.

Const PROCEDURE_NAME As String = MODULE_NAME & ".Remove"

    Call m_oVbExt.DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    mColElements.Remove lIndex
    
    
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
'This property allows you to enumerate this collection with the For...Each syntax.

    Set NewEnum = mColElements.[_NewEnum]
    
End Property

Private Sub Class_Initialize()

    'Create our vbExt object used for debug & trace messages.
    Set m_oVbExt = New vbExt
    
    'Creates the collection when this class is created.
    Set mColElements = New Collection
    
End Sub

Private Sub Class_Terminate()

    'Destroys collection when this class is terminated.
    Set mColElements = Nothing
    
    'Release our vbExt object used for debug & trace messages.
    Set m_oVbExt = Nothing
    
End Sub

